#include "project.h"

volatile uint16_t IRData = 0;
volatile uint8_t IRBit = 0;
volatile uint16_t IRLength = 0;
extern volatile unsigned SYSTEM_FLAGS;
volatile uint16_t BitTime;

void IR_Ready(void)
{

	P1SEL |= 0x04;
	IRBit = 14;										//Bit-Anzahl RC5 Signal, 2 Start-Flanken, 12 Daten-Flanken
	IRData = 0;
	IRLength = 0;
	CCTL1 = CM1 + SCS + CAP + CCIE;					//Capture-Modus, fallende Flanke, Sync + Interrupt
}

interrupt (TIMERA1_VECTOR) IR_ISR (void)
{
	switch(TAIV)
	{
		case 2:								//CCR1 Interrupt
		{
			if(CCTL1 & CAP)					//Flanke detektiert?
			{
				CCTL2 = 0;					//Timeout aus
				CCTL1 = CCIE;				//Compare Modus
				CCR1 += BIT_75;				//75% Bit Zeit
			}
			else
			{
				IRBit--;					//Ein Bit weniger
				if(!IRBit)					//Alle Bits eingesammelt?
				{
					CCTL1 = 0;				//Interrupt aus
					IRData &= 0x0FFF;		//12 Bits maskieren
					SYSTEM_FLAGS |= IR_RX_FLAG;	//Hauptprogramm benachrichtigen
				}
				else						//Noch nicht alle Bits
				{
					IRData = IRData << 1;	//1 weiter nach links schieben
					if(CCTL1 & SCCI)IRData |= 0x0001;	//1 oder 0 als LSB rein
					CCTL1 = CM1 + CM0 + CAP + CCIE + SCS;	//Beide Flanken, Capture, Interrupt
					CCR2 = CCR1 + BIT_50;			//Timeout einstellen, 50& Bit-Zeit
					CCTL2 = CCIE;					//Comapre, Interrupt
				}
			}

			break;
		}
		case 4:						//CCR2 Interrupt, Fehler im Signal
		{
			CCTL2 = 0;				//Int aus
			IR_Ready();				//Neu initialisieren
			break;
		}
		default:	break;			//andere TAI Vektoren

	}
}
